﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private zxBarcodeScanner As ZxingBarcodeScanner
	Private b1 As Button
	Private b2 As Button
	Private b3 As Button
	
	Private l1 As Label
	
	Dim flag As Int = 0
	Dim runningavg As Int = 127
	
	Private BarcodeScannerText As Label
	Private l3 As Label
	Private b4 As Button
	Private b5 As Button
	
	Dim scanStarted As Boolean = False
	
	Private nativeMe As JavaObject
	Dim rp As RuntimePermissions

	
	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
'	Root.LoadLayout("MainPage")
	
	'Do not forget to load the layout file created with the visual designer. For example:
	Root.LoadLayout("main")

	Dim Result As Boolean = True
	If Not(rp.Check(rp.PERMISSION_CAMERA)) Then
		rp.CheckAndRequest(rp.PERMISSION_CAMERA)
		Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	End If
	If Result Then
	
		nativeMe.InitializeContext
		
		l3.Text = ""
		zxBarcodeScanner.LaserColor = Colors.Yellow
		zxBarcodeScanner.MaskColor = Colors.ARGB(150, 0, 0, 200)'
		zxBarcodeScanner.BorderColor = Colors.Magenta
		zxBarcodeScanner.BorderStrokeWidth = 5
		zxBarcodeScanner.BorderLineLength = 40
		
		zxBarcodeScanner.AutoFocusInterval = 500
		zxBarcodeScanner.AutoFocus = True
		zxBarcodeScanner.FocusMode = zxBarcodeScanner.FOCUS_MODE_AUTO
		
		
		zxBarcodeScanner.Visible = False
		
	Else
		ToastMessageShow("未授予相机权限。", True)
		Return
	End If
	
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

'Private Sub Button1_Click
'	xui.MsgboxAsync("Hello world!", "B4X")
'End Sub



Sub Activity_Pause (UserClosed As Boolean)
	
	zxBarcodeScanner.Visible = False
	zxBarcodeScanner.stopScanner

End Sub


Sub b1_Click
	
	zxBarcodeScanner.toggleFlash
	
End Sub

Sub b2_Click
   
	zxBarcodeScanner.Visible = True
	zxBarcodeScanner.startScanner
	zxBarcodeScanner.TurnFlashOn
	scanStarted = True
	Log(zxBarcodeScanner.isFlashOn)
   
End Sub

Sub btn_scanClose_Click
	
	scanStarted = False
	zxBarcodeScanner.Visible = False
	zxBarcodeScanner.stopScanner
	l1.Text = ""
	BarcodeScannerText.Text = ""

End Sub

Sub b4_Click
	
	Dim zoomInValue As Int = 5                     'positive values -> zoon in
	If scanStarted Then
		If zxBarcodeScanner.CurrentZoomValue <= (zxBarcodeScanner.MaxZoomValue - zoomInValue) Then
			zxBarcodeScanner.zoomIn(zoomInValue)
		Else
			zxBarcodeScanner.zoomIn(zxBarcodeScanner.MaxZoomValue - zxBarcodeScanner.CurrentZoomValue)
		End If
	End If
	
End Sub

Sub b5_Click
	
	Dim zoomInValue As Int = -5                     'negative values -> zoom out
	If scanStarted Then
		If zxBarcodeScanner.CurrentZoomValue > (-1* zoomInValue) Then
			zxBarcodeScanner.zoomIn(zoomInValue)
		Else
			zxBarcodeScanner.zoomIn(0 - zxBarcodeScanner.CurrentZoomValue)
		End If
	End If
	
End Sub

Sub zxBarcodeScanner_scan_result (scantext As String, scanformat As String)
	nativeMe.RunMethod("playTone", Null)
	Dim tim As Long = 100
	nativeMe.RunMethod("vibrateOnce", Array(tim))
	Log ("B4A scan text = " & scantext)
	Log ("B4A scan format = " & scanformat)
	Log("isFlashOn = " & zxBarcodeScanner.isFlashOn)
	BarcodeScannerText.Text = scantext & " (type = " & scanformat & ")"
	
End Sub


Sub zxBarcodeScanner_brightness_changed (bright As Int )
	flag = flag + 1
	l1.Text = "亮度 = " & bright
	If flag = 30 Then' 
		flag = 0 
		If bright < 150 Then
			runningavg = (runningavg + bright) / 2
			If runningavg < 70 Then
				If Not(zxBarcodeScanner.isFlashOn) Then zxBarcodeScanner.TurnFlashOn
			Else if runningavg > 115 Then
				If zxBarcodeScanner.isFlashOn Then zxBarcodeScanner.TurnFlashOff
			End If
		End If
	End If
	l3.Text = "闪光灯开启 = " & zxBarcodeScanner.isFlashOn
	
End Sub

#If Java

import android.os.Vibrator;
import android.content.Context;

import android.media.ToneGenerator;
import android.media.AudioManager;

/**
*Vibrate with a given pattern. 
*Pass in an array of Longs that are the durations for which to turn on or off the vibrator in milliseconds. 
*The first value indicates the number of milliseconds to wait before turning the vibrator on. The next 
*value indicates the number of milliseconds for which to keep the vibrator on before turning it off. 
*Subsequent values alternate between durations in milliseconds to turn the vibrator off or to turn the vibrator on.
*Parameters:
*pattern ---> an array of longs of times for which to turn the vibrator on or off.
*repeat ---> the index into pattern at which to repeat, or -1 if you don't want to repeat.
*
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*/
public void vibratePattern(long[] pattern, int repeat) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
    v.vibrate(pattern, repeat);
  }
}

/**
*Cancel vibration (in case of method vibratePattern being active)
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*
*/
public void vibrateCancel(int dummy) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
     v.cancel();
  }
}

/**
*Vibrate continuously for the specified number of milliseconds 
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*/
public void vibrateOnce(long duration) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
     v.vibrate(duration);
  }
}


  public void playTone() {
	  final ToneGenerator tg = new ToneGenerator(AudioManager.STREAM_NOTIFICATION, 100);
	  tg.startTone(ToneGenerator.TONE_PROP_BEEP);
  }	  

#End If




